unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uMlSkinCountBar, GR32_Image_ml, uMlSkinCtrls, uMlSkinPanel,
  uMlSkinIconButtonList, VirtualTrees_ml, uMlSkinVirtualTree, uMlSkinNCCtrlBase,
  uMlSkinNCButton, uMlStdCtrl, uMlSkinForm, uMlSkinLabel, uMlSkinCheckBox,
  uMlSkinNCLabel, jpeg, uMlSkinIntf, GR32_ml, uMlComm;

type
  PColData = ^TColDataRec;

  TColDataRec = record
    Col1: string;
    Col2: string;
    Col3: string;
  end;

  TForm1 = class(TForm)
    mlcb1: TMlSkinCountBar;
    pnl1: TMlSkinPanel;
    mlvst1: TMlSkinVirtualStringTree;
    sf1: TMlSkinForm;
    systmbtn1: TMlSkinSystemButton;
    lbl1: TMlSkinLabel;
    chk1: TMlSkinCheckBox;
    systmbtn2: TMlSkinSystemButton;
    systmbtn3: TMlSkinSystemButton;
    nclbl1: TMlSkinNCLabel;
    procedure FormCreate(Sender: TObject);
    procedure mlcb1NumChanged(Sender: TObject);
    {$IFDEF UNICODE}
    procedure mlvst1DrawText(Sender: TBaseVirtualTree_ml; TargetCanvas: TCanvas;
      Node: PVirtualNode; Column: TColumnIndex; const Text: string; const
      CellRect: TRect; var DefaultDraw: Boolean);
    {$ELSE}
    procedure mlvst1DrawText(Sender: TBaseVirtualTree_ml;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      const Text: WideString; const CellRect: TRect;
      var DefaultDraw: Boolean);
    {$ENDIF}
    procedure mlvst1HeaderDraw(Sender: TVTHeader; HeaderCanvas: TCanvas; Column:
      TVirtualTreeColumn; R: TRect; Hover, Pressed: Boolean; DropMark: TVTDropMarkMode);
    procedure chk1Click(Sender: TObject);
    procedure pnl1BackgroundChanged(Sendre: TObject; ACanvas: TBitmap32);
    procedure mlvst1PaintBackground(Sender: TBaseVirtualTree_ml;
      TargetCanvas: TCanvas; R: TRect; var Handled: Boolean);
    procedure mlcb1SkipClick(Sender: TObject);
    procedure mlvst1NodeClick(Sender: TBaseVirtualTree_ml;
      const HitInfo: THitInfo);
  private
    { Private declarations }
    procedure LoadData(Page: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.chk1Click(Sender: TObject);
var
  po: TVTPaintOptions;
begin
  po := mlvst1.TreeOptions.PaintOptions;
  if chk1.Checked then
  begin
    mlcb1.NumCount := 40;
    sf1.Style := ssPicture;
    Include(po, toShowBackground);
  end
  else
  begin
    mlcb1.NumCount := 5;
    sf1.Style := ssColor;
    Exclude(po, toShowBackground);
  end;
  sf1.RefreshSkin;
  mlvst1.TreeOptions.PaintOptions := po;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  mlvst1.NodeDataSize := SizeOf(TColDataRec);
  LoadData(1);
end;

procedure TForm1.LoadData(Page: Integer);
var
  nd: PVirtualNode;
  pit: PColData;
  i: Integer;
begin
  lbl1.Caption := Format('ǰҳ%d', [Page]);
  with mlvst1 do
  begin
    try
      BeginUpdate;
      Clear;
      for i := 0 to 10 - 1 do
      begin
        nd := AddChild(nil);
        pit := GetNodeData(nd);
        pit^.Col1 := Format('%dҳ - %d', [Page, i]);
        pit^.Col2 := Format('a=%d', [i * Page]);
        pit^.Col3 := 'Test';
      end;
    finally
      EndUpdate;
    end;
  end;
end;

procedure TForm1.mlcb1NumChanged(Sender: TObject);
begin
  LoadData(mlcb1.FocusNum);
end;

procedure TForm1.mlcb1SkipClick(Sender: TObject);
begin
  ShowMessage('SkipTo Clicked');
end;
{$IFDEF UNICODE}
procedure TForm1.mlvst1DrawText(Sender: TBaseVirtualTree_ml; TargetCanvas:
  TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const
  CellRect: TRect; var DefaultDraw: Boolean);
{$ELSE}
procedure TForm1.mlvst1DrawText(Sender: TBaseVirtualTree_ml;
  TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  const Text: WideString; const CellRect: TRect; var DefaultDraw: Boolean);
{$ENDIF}
var
  R, TR: TRect;
  pit: PColData;
  s: string;
  Bmp32: TBitmap32;
  c32: TColor32;
  w, h: Integer;
begin
  DefaultDraw := False;
  pit := Sender.GetNodeData(Node);
  R := CellRect;
  if chk1.Checked then // ͸ģʽ
  begin
    Bmp32 := TBitmap32.Create;
    w := GetRectWidth(R);
    h := GetRectHeight(R);
    Bmp32.SetSize(w, h);
    TR := Rect(0, 0, Bmp32.Width, Bmp32.Height);
    Bmp32.Draw(TR, CellRect, TargetCanvas.Handle);
    if vsSelected in Node.States then
    begin
      // ѡ״̬
      c32 := Color32($00FFC832);
    end
    else
    begin
      // 
      if Node.Index mod 2 = 0 then
        c32 := Color32(clWhite)
      else
        c32 := Color32($00F6F6F6);
    end;
    c32 := SetAlpha(c32, 196);  //͸
    Bmp32.FillRectTS(TR, c32);
    case Column of
      0:
        s := pit^.Col1;
      1:
        s := pit^.Col2;
      2:
        s := pit^.Col3;
    end;
    TR.Left := TR.Left + 4;
    Bmp32.Font.Assign(TargetCanvas.Font);
    Bmp32.Textout(TR, DT_LEFT + DT_VCENTER + DT_SINGLELINE, s);
    Bmp32.DrawTo(TargetCanvas.Handle, R.Left, R.Top);
    Bmp32.Free;
  end
  else         //͸
  begin
    if vsSelected in Node.States then
    begin
      // ѡ״̬
      TargetCanvas.Brush.Color := $00FFC832;
    end
    else
    begin
      // 
      if Node.Index mod 2 = 0 then
        TargetCanvas.Brush.Color := clWhite
      else
        TargetCanvas.Brush.Color := $00F6F6F6;
    end;
    TargetCanvas.FillRect(R);
    case Column of
      0:
        s := pit^.Col1;
      1:
        s := pit^.Col2;
      2:
        s := pit^.Col3;
    end;
    R.Left := R.Left + 4;
    {$IFDEF UNICODE}
      TargetCanvas.TextRect(R, s, [tfLeft, tfVerticalCenter, tfSingleLine]);
    {$ELSE}
      TargetCanvas.TextOut(r.Left, r.Top + 7, s);
    {$ENDIF}
  end;
end;

procedure TForm1.mlvst1HeaderDraw(Sender: TVTHeader; HeaderCanvas: TCanvas;
  Column: TVirtualTreeColumn; R: TRect; Hover, Pressed: Boolean; DropMark:
  TVTDropMarkMode);
var
  s: string;
  Bmp32: TBitmap32;
  TR, DR: TRect;
  c32: TColor32;
  nd: PVirtualNode;
begin
  // Իͷ
  s := Column.Text;
  if chk1.Checked then   //͸ģʽ
  begin
    Bmp32 := TBitmap32.Create;
    with Bmp32 do
    begin
      SetSize(GetRectWidth(R), GetRectHeight(R));
      TR := Rect(0, 0, Bmp32.Width, Bmp32.Height);
      DR := R;
      OffsetRect(DR, 1, 1);
      pnl1.BackgroundPicture.DrawTo(Bmp32, TR, DR);
      c32 := Color32($004966FE);
      c32 := SetAlpha(c32, 196);  //͸
      FillRectTS(TR, c32);
      Font.Assign(HeaderCanvas.Font);
      Font.Color := clWhite;
      TR.Left := TR.Left + 4;
      Textout(TR, DT_LEFT + DT_VCENTER + DT_SINGLELINE, s);
      DrawTo(HeaderCanvas.Handle, R.Left, R.Top);
    end;
    Bmp32.Free;
  end
  else
  begin
    with HeaderCanvas do
    begin
      Brush.Color := $004966FE;
      FillRect(R);
      R.Left := R.Left + 4;
      Font.Color := clWhite;
    {$IFDEF UNICODE}
      TextRect(R, s, [tfLeft, tfSingleLine, tfVerticalCenter]);
    {$ELSE}
      TextOut(r.Left, r.Top + 7, s);
    {$ENDIF}
    end;
  end;
end;

procedure TForm1.mlvst1NodeClick(Sender: TBaseVirtualTree_ml;
  const HitInfo: THitInfo);
var
  pit: PColData;
begin
  with Sender do
  begin
    pit := GetNodeData(HitInfo.HitNode);
    ShowMessage(pit^.Col1);
  end;
end;

procedure TForm1.mlvst1PaintBackground(Sender: TBaseVirtualTree_ml;
  TargetCanvas: TCanvas; R: TRect; var Handled: Boolean);
var
  Bmp32: TBitmap32;
  TR, DR: TRect;
  c32: TColor32;
  nd: PVirtualNode;
begin
  if chk1.Checked then  //͸ģʽ
  begin
    //¿հ׵ĵط (Խע͵ԱһʾЧ)
    Handled := True;
    Bmp32 := TBitmap32.Create;
    with Bmp32 do
    begin
      SetSize(GetRectWidth(R), GetRectHeight(R));
      TR := Rect(0, 0, Bmp32.Width, Bmp32.Height);
      nd := Sender.GetLast;
      DR := R;
      if nd <> nil then
      begin
        DR := Sender.GetDisplayRect(nd, -1, False);
        DR.Top := DR.Top + mlvst1.Header.Height + 2;
        DR.Bottom := DR.Top + Bmp32.Height;
      end;
      Bmp32.Draw(TR, DR, mlvst1.Background.Bitmap.Canvas.Handle);
      c32 := Color32(mlcb1.Color);
      c32 := SetAlpha(c32, 196);  //͸
      FillRectTS(TR, c32);
      DrawTo(TargetCanvas.Handle, R.Left, R.Top);
    end;
    Bmp32.Free;
  end;
end;

procedure TForm1.pnl1BackgroundChanged(Sendre: TObject; ACanvas: TBitmap32);
var
  x, y: Integer;
begin
  with mlvst1 do
  begin
    Background.Bitmap.Width := ACanvas.Width;
    Background.Bitmap.Height := ACanvas.Height;
    // ΪPanelһصı߿Ҫȥ
    x := -1;
    y := -Header.Height - 1;  //ͷ߶ҲҪȥ
    pnl1.BackgroundPicture.DrawTo(Background.Bitmap.Canvas.Handle, x, y);
    Invalidate;
  end;
end;


end.

