unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32_Image_ml, uMlSkinCtrls, uMlSkinPanel, uMlStdCtrl, uMlSkinForm,
  uMlSkinLine, uMlSkinLabel, uMlSkinNCCtrlBase, uMlSkinNCButton, uMlSkinNCLabel,
  uMlLottery, VirtualTrees_ml, uMlSkinVirtualTree, GR32_ml, uMlComm,
  uMlSkinScrollBar;

type
  PColData = ^TColDataRec;

  TColDataRec = record
    Col1: string;
    Col2: string;
  end;

  TForm1 = class(TForm)
    pnl1: TMlSkinPanel;
    sf1: TMlSkinForm;
    pnl2: TMlSkinPanel;
    lbl1: TMlSkinLabel;
    ln1: TMlSkinLine;
    ln2: TMlSkinLine;
    ncbtn1: TMlSkinNCButton;
    nclbl1: TMlSkinNCLabel;
    lbl2: TMlSkinLabel;
    nclbl2: TMlSkinNCLabel;
    mlvst1: TMlSkinVirtualStringTree;
    sb1: TMlSkinScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure ncbtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    {$IFDEF UNICODE}
    procedure mlvst1DrawText(Sender: TBaseVirtualTree_ml; TargetCanvas: TCanvas;
      Node: PVirtualNode; Column: TColumnIndex; const Text: string; const
      CellRect: TRect; var DefaultDraw: Boolean);
    {$ELSE}
    procedure mlvst1DrawText(Sender: TBaseVirtualTree_ml;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      const Text: WideString; const CellRect: TRect;
      var DefaultDraw: Boolean);
    {$ENDIF}
    procedure mlvst1HeaderDraw(Sender: TVTHeader; HeaderCanvas: TCanvas; Column:
      TVirtualTreeColumn; R: TRect; Hover, Pressed: Boolean; DropMark: TVTDropMarkMode);
    procedure pnl2BackgroundChanged(Sendre: TObject; ACanvas: TBitmap32);
  private
    { Private declarations }
    FMlLottery: TMlLottery;
    FImagePath: string;
    procedure InitImages;
    procedure DoOnTurnDone(Sender: TObject; const HotIndex: Integer);
    procedure AddToList(const UserName, PrizeText: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.DoOnTurnDone(Sender: TObject; const HotIndex: Integer);
var
  s: string;
  x, y, a: Double;
begin
  FMlLottery.PrizesData.GetText(HotIndex, s, x, y, a);
  AddToList('XXX', s);
//  OutputDebugString(PChar(Format('Ʒƣ%s %d', [s, HotIndex])));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FImagePath := ExtractFilePath(ParamStr(0)) + 'Images\';
  //̬ҡԲ̣ȻΪԺ󷽱ʹãҲԽŪһ
  FMlLottery := TMlLottery.Create(pnl1);
  with FMlLottery do
  begin
    Parent := pnl1;
    Left := 435;
    Top := 50;
    Anchors := [akLeft, akTop, akRight, akBottom];
    ImagePath := FImagePath;
    PrizesData.LoadFromFile(ExtractFilePath(ParamStr(0)) + 'Data.txt');  //Ʒб ע⣺ƷһҪż
//    DebugMode := True;
    HotIndex := 1;
    OnTurnDone := DoOnTurnDone;
  end;
  InitImages;
  mlvst1.NodeDataSize := SizeOf(TColDataRec);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FMlLottery.Free;
end;

procedure TForm1.InitImages;
begin
  sf1.CustomPicture := FImagePath + '56612ce3Na656bb98.png';
  pnl1.BackgroundImage := FImagePath + '56654bf7N5278a331.png';
  ncbtn1.Picture.Image := FImagePath + 'icons8-Delete-32.png';
end;

procedure TForm1.AddToList(const UserName, PrizeText: string);
var
  nd: PVirtualNode;
  pit: PColData;
begin
  with mlvst1 do
  begin
    nd := AddChild(nil);
    pit := GetNodeData(nd);
    pit^.Col1 := UserName;
    pit^.Col2 := PrizeText;
  end;
end;

{$IFDEF UNICODE}
procedure TForm1.mlvst1DrawText(Sender: TBaseVirtualTree_ml; TargetCanvas:
  TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const
  CellRect: TRect; var DefaultDraw: Boolean);
{$ELSE}
procedure TForm1.mlvst1DrawText(Sender: TBaseVirtualTree_ml;
  TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  const Text: WideString; const CellRect: TRect; var DefaultDraw: Boolean);
{$ENDIF}
var
  R, TR: TRect;
  pit: PColData;
  s: string;
  Bmp32: TBitmap32;
  w, h: Integer;
begin
  DefaultDraw := False;
  pit := Sender.GetNodeData(Node);
  R := CellRect;
  Bmp32 := TBitmap32.Create;
  w := GetRectWidth(R);
  h := GetRectHeight(R);
  Bmp32.SetSize(w, h);
  TR := Rect(0, 0, Bmp32.Width, Bmp32.Height + 1);
  Bmp32.Draw(TR, CellRect, TargetCanvas.Handle);
  case Column of
    0:
      begin
        TargetCanvas.Font.Color := $008D8992;
        s := pit^.Col1;
      end;
    1:
      begin
        TargetCanvas.Font.Color := $00494CF3;
        s := pit^.Col2;
      end;
  end;
  TR.Left := TR.Left + 15;
  Bmp32.Font.Assign(TargetCanvas.Font);
  Bmp32.Textout(TR, DT_LEFT + DT_VCENTER + DT_SINGLELINE, s);
  Bmp32.DrawTo(TargetCanvas.Handle, R.Left, R.Top);
  Bmp32.Free;
end;

procedure TForm1.mlvst1HeaderDraw(Sender: TVTHeader; HeaderCanvas: TCanvas;
  Column: TVirtualTreeColumn; R: TRect; Hover, Pressed: Boolean; DropMark:
  TVTDropMarkMode);
var
  s: string;
  Bmp32: TBitmap32;
  TR, DR: TRect;
  nd: PVirtualNode;
  c32: TColor32;
begin
  // Իͷ
  s := Column.Text;
  Bmp32 := TBitmap32.Create;
  with Bmp32 do
  begin
    SetSize(GetRectWidth(R), GetRectHeight(R));
    TR := Rect(0, 0, Bmp32.Width, Bmp32.Height);
    DR := R;
    OffsetRect(DR, 0, mlvst1.Top);
    pnl2.BackgroundPicture.DrawTo(Bmp32, TR, DR);
    Font.Assign(HeaderCanvas.Font);
    Font.Color := clMaroon;
    TR.Left := TR.Left + 20;
    Textout(TR, DT_LEFT + DT_VCENTER + DT_SINGLELINE, s);
    DrawTo(HeaderCanvas.Handle, R.Left, R.Top);
  end;
  Bmp32.Free;
end;

procedure TForm1.ncbtn1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.pnl2BackgroundChanged(Sendre: TObject; ACanvas: TBitmap32);
var
  x, y: Integer;
  Bmp32: TBitmap32;
  c32: TColor32;
begin
  //ʹListı͸
  Bmp32 := TBitmap32.Create;
  with mlvst1 do
  begin
    Background.Bitmap.Width := ACanvas.Width;
    Background.Bitmap.Height := ACanvas.Height;
    x := 0;
    y := -Header.Height - mlvst1.Top;
    Bmp32.SetSize(pnl2.BackgroundPicture.Width, pnl2.BackgroundPicture.Height);
    pnl2.BackgroundPicture.DrawTo(Bmp32, 0, 0);
    c32 := Color32(pnl2.Color);
    c32 := SetAlpha(c32, pnl2.Alpha);  //͸
    Bmp32.FillRectTS(Bmp32.ClipRect, c32);
    Bmp32.DrawTo(Background.Bitmap.Canvas.Handle, x, y);
    Invalidate;
  end;
  Bmp32.Free;
end;

end.

