unit frmMlFormSkinEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, uMlMessages,
  uMlFormSkinVar, Controls, Forms, Dialogs, StdCtrls, ComCtrls, uMlHLSTrackBar,
  ExtCtrls, ActnList, uMlSkinButton, uMlStdCtrl, uMlSkinForm, uMlSkinNCCtrlBase,
  uMlSkinNCButton, uMlSkinNCLabel, uMlSkinPanel, uMlSkinCheckBox,
  uMlCustomButton, uMlSkinCtrls, uMlSkinEdit, uMlSkinLabel, GR32_Image_ml;

type
  TMlFormSkinEditorForm = class(TForm)
    actlst1: TActionList;
    actColorReset: TAction;
    actLoadPicture: TAction;
    actApplyDefault: TAction;
    mlsknpnl1: TMlSkinPanel;
    tkB: TMlHLSTrackBar;
    tkS: TMlHLSTrackBar;
    tkH: TMlHLSTrackBar;
    mlsknpnl3: TMlSkinPanel;
    btnColorReset: TMlSkinButton;
    mlsknpnl2: TMlSkinPanel;
    btnSkin1: TMlSkinImageButton;
    btnSkin2: TMlSkinImageButton;
    btnSkin3: TMlSkinImageButton;
    btnSkin4: TMlSkinImageButton;
    btnSkin5: TMlSkinImageButton;
    btnSkin6: TMlSkinImageButton;
    btnSkin7: TMlSkinImageButton;
    btnSkin8: TMlSkinImageButton;
    btnLoadPicture: TMlSkinToolButton;
    sknfrm1: TMlSkinForm;
    btn8: TMlSkinSystemButton;
    nclbl1: TMlSkinNCLabel;
    edtH: TMlSkinEdit;
    edtS: TMlSkinEdit;
    edtB: TMlSkinEdit;
    lbl1: TMlSkinLabel;
    lbl2: TMlSkinLabel;
    lbl3: TMlSkinLabel;
    procedure tkHChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edtHKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure edtHKeyPress(Sender: TObject; var Key: Char);
    procedure actColorResetExecute(Sender: TObject);
    procedure actLoadPictureExecute(Sender: TObject);
    procedure actApplyDefaultExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSkin1Click(Sender: TObject);
  private
    FLock: Boolean;
    FSkinColor: TColor;
    FClientColor: TColor;
    procedure SetSkinColor(const Value: TColor);
    procedure SetClientColor(const Value: TColor);
    procedure Load;
    procedure Save;
    { Private declarations }
  public
    { Public declarations }
    property SkinColor: TColor read FSkinColor write SetSkinColor;
    property ClientColor: TColor read FClientColor write SetClientColor;
  end;

implementation

uses
  uMlSkinHelper, uSkinRes, uMlSkinIntf, uMlSkinResManager;

{$R *.dfm}
{ TMlFormSkinEditorForm }

procedure TMlFormSkinEditorForm.actApplyDefaultExecute(Sender: TObject);
begin
  MainSkinRes.mlsknrs1.ApplyDefault;
  Load;
end;

procedure TMlFormSkinEditorForm.actColorResetExecute(Sender: TObject);
begin
  tkH.Lock;
  tkS.Lock;
  tkH.Value := 0;
  tkS.Value := 0;
  tkH.UnLock;
  tkS.UnLock;
  tkB.Value := 0;
end;

procedure TMlFormSkinEditorForm.actLoadPictureExecute(Sender: TObject);
var
  Ext, NewFile: string;
begin
  with TOpenDialog.Create(Self) do
  begin
    Filter := 'Png(*.png),Jpeg(*.jpg),Bmp(*.bmp)|*.png;*.jpg;*.bmp';
    if Execute then
    begin
      Ext := ExtractFileExt(FileName);
      NewFile := ExtractFilePath(ParamStr(0)) + 'Skin\Custom\FormBg' + Ext;
      if CopyFile(PChar(FileName), PChar(NewFile), False) then
      begin
        btnSkin1.Down := False;
        btnSkin2.Down := False;
        btnSkin3.Down := False;
        btnSkin4.Down := False;
        btnSkin5.Down := False;
        btnSkin6.Down := False;
        btnSkin7.Down := False;
        btnSkin8.Down := False;
        try
          MainSkinRes.mlsknrs1.Form.BeginUpdate;
          MainSkinRes.mlsknrs1.Form.DefaultSkinOrder := -1;
          //עΪ˽ʡڴ棬ԴͷһùıͼƬѡ
          TMlSkinResManagerObj.Delete(NewFile);

          MainSkinRes.mlsknrs1.Form.CustomPictureName := ExtractFileName(NewFile);
          MainSkinRes.mlsknrs1.Form.Style := ssPicture;
        finally
          MainSkinRes.mlsknrs1.Form.EndUpdate;
        end;
      end;
    end;
    Free;
  end;
end;

procedure TMlFormSkinEditorForm.btnSkin1Click(Sender: TObject);
var
  tg: Integer;
  sf, dskpath, nf: string;
begin
  Application.ProcessMessages;
  tg := TMlSkinImageButton(Sender).Tag;
  try
    MainSkinRes.mlsknrs1.Form.BeginUpdate;
    MainSkinRes.mlsknrs1.Form.DefaultSkinOrder := tg;
    if tg > 0 then
    begin
      dskpath := ExtractFilePath(ParamStr(0)) + 'Skin\Default\';
      case tg of
        1:
          sf := 'skin_bk_sea.jpg';
        2:
          sf := 'skin_bk_leaf.jpg';
        3:
          sf := 'skin_bk_night.jpg';
        4:
          sf := 'skin_bk_forest.jpg';
        5:
          sf := 'skin_bk_lake.jpg';
        6:
          sf := 'skin_bk_water.jpg';
        7:
          sf := 'skin_bk_glass.jpg';
      end;
      sf := dskpath + sf;
      nf := ExtractFilePath(ParamStr(0)) + 'Skin\Custom\FormBg.jpg';
      CopyFile(PChar(sf), PChar(nf), False);
      //עΪ˽ʡڴ棬ԴͷһùıͼƬѡ
      TMlSkinResManagerObj.Delete(nf);

      MainSkinRes.mlsknrs1.Form.CustomPictureName := ExtractFileName(nf);
      MainSkinRes.mlsknrs1.Form.Style := ssPicture;
    end
    else
      MainSkinRes.mlsknrs1.Form.Style := ssColor;
  finally
    MainSkinRes.mlsknrs1.Form.EndUpdate;
  end;
end;

procedure TMlFormSkinEditorForm.edtHKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key in ['a'..'z']) or (Key in ['A'..'Z']) then
    Key := #0;
end;

procedure TMlFormSkinEditorForm.edtHKeyUp(Sender: TObject; var Key: Word; Shift:
  TShiftState);
var
  i: Integer;
begin
  FLock := True;
  if edtH.Text = '-0' then
    edtH.Text := '-1';
  if edtS.Text = '-0' then
    edtS.Text := '-1';
  if edtB.Text = '-0' then
    edtB.Text := '-1';
  tkH.Value := StrToIntDef(edtH.Text, 0);
  tkS.Value := StrToIntDef(edtS.Text, 0);
  tkB.Value := StrToIntDef(edtB.Text, 0);
  edtH.Text := IntToStr(gHSB.h);
  edtS.Text := IntToStr(gHSB.s);
  edtB.Text := IntToStr(gHSB.b);
  FLock := False;
  for i := TMlFormSkinHelperObj.Items.Count - 1 downto 0 do
  begin
    Application.ProcessMessages;
    SendMessage(PFormSkinHelperData(TMlFormSkinHelperObj.Items[i])^.Form.Handle,
      MM_HSBCHANGED, 0, 0);
  end;
end;

procedure TMlFormSkinEditorForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save;
end;

procedure TMlFormSkinEditorForm.FormCreate(Sender: TObject);
begin
  Load;
end;

procedure TMlFormSkinEditorForm.Load;
begin
  tkH.Lock;
  tkS.Lock;
  tkB.Lock;
  tkH.Value := gHSB.h;
  tkS.Value := gHSB.s;
  tkB.Value := gHSB.b;
  edtH.Text := IntToStr(gHSB.h);
  edtS.Text := IntToStr(gHSB.s);
  edtB.Text := IntToStr(gHSB.b);
  tkH.UnLock;
  tkS.UnLock;
  tkB.UnLock;
  case MainSkinRes.mlsknrs1.Form.DefaultSkinOrder of
    0:
      btnSkin1.Down := True;
    1:
      btnSkin2.Down := True;
    2:
      btnSkin3.Down := True;
    3:
      btnSkin4.Down := True;
    4:
      btnSkin5.Down := True;
    5:
      btnSkin6.Down := True;
    6:
      btnSkin7.Down := True;
    7:
      btnSkin8.Down := True;
  end;
end;

procedure TMlFormSkinEditorForm.Save;
begin
  MainSkinRes.mlsknrs1.Save;
end;

procedure TMlFormSkinEditorForm.SetClientColor(const Value: TColor);
begin
  FClientColor := Value;
end;

procedure TMlFormSkinEditorForm.SetSkinColor(const Value: TColor);
begin
  FSkinColor := Value;
end;

procedure TMlFormSkinEditorForm.tkHChange(Sender: TObject);
var
  i: Integer;
begin
  gHSB.h := tkH.Value;
  gHSB.s := tkS.Value;
  gHSB.b := tkB.Value;
  if not FLock then
  begin
    try
      FLock := True;
      edtH.Text := IntToStr(gHSB.h);
      edtS.Text := IntToStr(gHSB.s);
      edtB.Text := IntToStr(gHSB.b);
      for i := TMlFormSkinHelperObj.Items.Count - 1 downto 0 do
      begin
        Application.ProcessMessages;
        SendMessage(PFormSkinHelperData(TMlFormSkinHelperObj.Items[i])^.Form.Handle,
          MM_HSBCHANGED, 0, 0);
      end;
    finally
      FLock := False;
    end;
  end;
end;

end.


